{{File: Servos.spin

The top level program stores the pulse width information in a variable
(or an array of variables for multiple servos).  This object checks the
variable value (or each array element) and updates the pulse widths
transmitted to each servo every 20 ms.
}}

con
  _CLKMODE      = XTAL1 + PLL16X
  _XINFREQ      = 5_000_000

  Clock         = 80_000_000
  ms20          = $00186A00

  Lcenter       = 120000
  Rcenter       = 120000
  ModeNCO       = %00100 << 26       ' Bit 31 overflow goes to pin
  #0,Left,Right

Obj
  Defs : "BB_Defs"
  
var
  long SpeedL, SpeedR, stack[32]
  byte cog

Pub start(MLP,MRP)| okay ' Left/Right MotorPin, & EncoderClk/EncoderDir
   okay := (cog := cognew(servo(MLP,MRP), @stack) + 1)

Pub Stop
   if cog
      cogstop(cog~ -1)

Pub SetSpeed(Sl,Sr)         ' Speed is given in micro Seconds
  SpeedL := Sl
  SpeedR := Sr

Pri Servo(MlPin, MrPin) | T,tHi           
   Dira |= |<MlPin + |<MrPin                 ' pins -> output
   Frqa := 1                                 ' Setup the counters
   Frqb := 1
   Phsa := 0
   Phsb := 0                         
   Ctra := ModeNCO + MlPin
   Ctrb := ModeNCO + MrPin
   T := cnt                                  ' Get current time
   repeat                                    ' Loop forever
      tHi := LCenter + SpeedL
      Phsa := -tHi
      tHi := RCenter + SpeedR * -1
      Phsb := -tHi     
      waitcnt(T += ms20)                     ' Wait 20 Ms
      